#import "TeXFoGcontroller.h"
#import	"MyDocument.h"
#import "GlobalConstants.h"

@implementation TeXFoGcontroller

- init
{
    //NSLog(@"Initialising controller");
    [super init];
    version=[NSMutableString stringWithString:@""];
    [version retain];
    [self readDefaults];
    if(![version isEqualToString:kDefaultVersionString] || (version == NULL))
    {
        // first time ever !!
        [self setFirstTimeDefaults];
        //[self readDefaults];
    }
    return self;
}

- (void)dealloc
{
	[latexEnginePath release];
	[ghostscriptEnginePath release];
	[editor release];
	[version release];
	[super dealloc];
}

- (void)windowDidLoad
{
    MyDocument	*doc;
    NSFont	*font;
    
    [super windowDidLoad];
    [[self window] makeFirstResponder:editableText];
    
    doc=[self document];
    font=[NSFont fontWithName:@"Monaco" size:12];
    [editableText setFont:font];
    if([doc hasFrame])
    {
        // sto caricando da un file
        [[self window] setFrame:[doc frame] display:YES];
        [editableText setFont:[doc font]];
        [editableText replaceCharactersInRange:NSMakeRange(0,0) withRTFD:[doc getText]];
    }
}

- (NSString *)windowTitleForDocumentDisplayName:(NSString *)displayName
{
    return [@"TeX FoG: " stringByAppendingString:displayName];
}

- (void)awakeFromNib
{
	NSMutableString	*titolo=[NSMutableString stringWithString:@"Paste into "];
	
	[self readDefaults];
	[titolo appendString:editor];
	[pasteIntoEditorButton setTitle:titolo];
}

- (void)synchronizeData
{
    MyDocument		*doc=[self document];
    
    [doc setFrame:[[self window] frame]];
    [editableText selectAll:self];
    [doc setText:[editableText RTFDFromRange:[editableText selectedRange]]];
    [doc setFont:[editableText font]];
}

- (IBAction) doSuper:(id)sender
{
    [editableText insertText:kSuperscript];
    [self moveInsertionPointBy:1];
}

- (IBAction) doSub:(id)sender
{
    [editableText insertText:kSubscript];
    [self moveInsertionPointBy:1];
}

- (IBAction) doFraction:(id)sender
{
    [editableText insertText:kFraction];
    [self moveInsertionPointBy:3];
}

- (IBAction) doRoot:(id)sender
{
    [editableText insertText:kRoot];
    [self moveInsertionPointBy:1];
}

- (IBAction) doRootN:(id)sender
{
    [editableText insertText:kRootN];
    [self moveInsertionPointBy:3];
}

- (IBAction) doLowEllipsis:(id)sender
{
    [editableText insertText:kLowEllipsis];
}

- (IBAction) doCenteredEllipsis:(id)sender
{
    [editableText insertText:kCenteredEllipsis];
}

- (IBAction) doVerticalDots:(id)sender
{
    [editableText insertText:kVerticalDots];
}

- (IBAction) doDiagonalDots:(id)sender
{
    [editableText insertText:kDiagonalDots];
}

- (IBAction) doalpha:(id)sender
{
    [editableText insertText:kalpha];
}

- (IBAction) dobeta:(id)sender
{
    [editableText insertText:kbeta];
}

- (IBAction) dogamma:(id)sender
{
    [editableText insertText:kgamma];
}

- (IBAction) dodelta:(id)sender
{
    [editableText insertText:kdelta];
}

- (IBAction) doepsilon:(id)sender
{
    [editableText insertText:kepsilon];
}

- (IBAction) dovarepsilon:(id)sender
{
    [editableText insertText:kvarepsilon];
}

- (IBAction) dozeta:(id)sender
{
    [editableText insertText:kzeta];
}

- (IBAction) doeta:(id)sender
{
    [editableText insertText:keta];
}

- (IBAction) dotheta:(id)sender
{
    [editableText insertText:ktheta];
}

- (IBAction) dovartheta:(id)sender
{
    [editableText insertText:kvartheta];
}

- (IBAction) doiota:(id)sender
{
    [editableText insertText:kiota];
}

- (IBAction) dokappa:(id)sender
{
    [editableText insertText:kkappa];
}

- (IBAction) dolambda:(id)sender
{
    [editableText insertText:klambda];
}

- (IBAction) domu:(id)sender
{
    [editableText insertText:kmu];
}

- (IBAction) donu:(id)sender
{
    [editableText insertText:knu];
}

- (IBAction) doxi:(id)sender
{
    [editableText insertText:kxi];
}

- (IBAction) doo:(id)sender
{
    [editableText insertText:ko];
}

- (IBAction) dopi:(id)sender
{
    [editableText insertText:kpi];
}

- (IBAction) dovarpi:(id)sender
{
    [editableText insertText:kvarpi];
}

- (IBAction) dorho:(id)sender
{
    [editableText insertText:krho];
}

- (IBAction) dovarrho:(id)sender
{
    [editableText insertText:kvarrho];
}

- (IBAction) dosigma:(id)sender
{
    [editableText insertText:ksigma];
}

- (IBAction) dovarsigma:(id)sender
{
    [editableText insertText:kvarsigma];
}

- (IBAction) dotau:(id)sender
{
    [editableText insertText:ktau];
}

- (IBAction) doupsilon:(id)sender
{
    [editableText insertText:kupsilon];
}

- (IBAction) dophi:(id)sender
{
    [editableText insertText:kphi];
}

- (IBAction) dovarphi:(id)sender
{
    [editableText insertText:kvarphi];
}

- (IBAction) dochi:(id)sender
{
    [editableText insertText:kchi];
}

- (IBAction) dopsi:(id)sender
{
    [editableText insertText:kpsi];
}

- (IBAction) doomega:(id)sender
{
    [editableText insertText:komega];
}

- (IBAction) doGamma:(id)sender
{
    [editableText insertText:kGamma];
}

- (IBAction) doDelta:(id)sender
{
    [editableText insertText:kDelta];
}

- (IBAction) doTheta:(id)sender
{
    [editableText insertText:kTheta];
}

- (IBAction) doLambda:(id)sender
{
    [editableText insertText:kLambda];
}

- (IBAction) doXi:(id)sender
{
    [editableText insertText:kXi];
}

- (IBAction) doPi:(id)sender
{
    [editableText insertText:kPi];
}

- (IBAction) doSigma:(id)sender
{
    [editableText insertText:kSigma];
}

- (IBAction) doUpsilon:(id)sender
{
    [editableText insertText:kUpsilon];
}

- (IBAction) doPhi:(id)sender
{
    [editableText insertText:kPhi];
}

- (IBAction) doPsi:(id)sender
{
    [editableText insertText:kPsi];
}

- (IBAction) doOmega:(id)sender
{
    [editableText insertText:kOmega];
}

- (IBAction) doCalligraphic:(id)sender
{
    [editableText insertText:kCalligraphic];
    [self moveInsertionPointBy:1];
}

- (IBAction) dopm:(id)sender
{
    [editableText insertText:kpm];
}

- (IBAction) domp:(id)sender
{
    [editableText insertText:kmp];
}

- (IBAction) dotimes:(id)sender
{
    [editableText insertText:ktimes];
}

- (IBAction) dodiv:(id)sender
{
    [editableText insertText:kdiv];
}

- (IBAction) doast:(id)sender
{
    [editableText insertText:kast];
}

- (IBAction) dostar:(id)sender
{
    [editableText insertText:kstar];
}

- (IBAction) docirc:(id)sender
{
    [editableText insertText:kcirc];
}

- (IBAction) dobullet:(id)sender
{
    [editableText insertText:kbullet];
}

- (IBAction) docdot:(id)sender
{
    [editableText insertText:kcdot];
}

- (IBAction) docap:(id)sender
{
    [editableText insertText:kcap];
}

- (IBAction) docup:(id)sender
{
    [editableText insertText:kcup];
}

- (IBAction) douplus:(id)sender
{
    [editableText insertText:kuplus];
}

- (IBAction) dosqcap:(id)sender
{
    [editableText insertText:ksqcap];
}

- (IBAction) dosqcup:(id)sender
{
    [editableText insertText:ksqcup];
}

- (IBAction) dovee:(id)sender
{
    [editableText insertText:kvee];
}

- (IBAction) dowedge:(id)sender
{
    [editableText insertText:kwedge];
}

- (IBAction) dosetminus:(id)sender
{
    [editableText insertText:ksetminus];
}

- (IBAction) dowr:(id)sender
{
    [editableText insertText:kwr];
}

- (IBAction) dodiamond:(id)sender
{
    [editableText insertText:kdiamond];
}

- (IBAction) dobigtriangleup:(id)sender
{
    [editableText insertText:kbigtriangleup];
}

- (IBAction) dobigtriangledown:(id)sender
{
    [editableText insertText:kbigtriangledown];
}

- (IBAction) dotriangleleft:(id)sender
{
    [editableText insertText:ktriangleleft];
}

- (IBAction) dotriangleright:(id)sender
{
    [editableText insertText:ktriangleright];
}

- (IBAction) dolhd:(id)sender
{
    [editableText insertText:klhd];
}

- (IBAction) dorhd:(id)sender
{
    [editableText insertText:krhd];
}

- (IBAction) dounlhd:(id)sender
{
    [editableText insertText:kunlhd];
}

- (IBAction) dounrhd:(id)sender
{
    [editableText insertText:kunrhd];
}

- (IBAction) dooplus:(id)sender
{
    [editableText insertText:koplus];
}

- (IBAction) doominus:(id)sender
{
    [editableText insertText:kominus];
}

- (IBAction) dootimes:(id)sender
{
    [editableText insertText:kotimes];
}

- (IBAction) dooslash:(id)sender
{
    [editableText insertText:koslash];
}

- (IBAction) doodot:(id)sender
{
    [editableText insertText:kodot];
}

- (IBAction) dobigcirc:(id)sender
{
    [editableText insertText:kbigcirc];
}

- (IBAction) dodagger:(id)sender
{
    [editableText insertText:kdagger];
}

- (IBAction) doddagger:(id)sender
{
    [editableText insertText:kddagger];
}

- (IBAction) doamalg:(id)sender
{
    [editableText insertText:kamalg];
}

- (IBAction) doNegate:(id)sender
{
    [editableText insertText:kNegate];
}

- (IBAction) doLeftParenthesis:(id)sender
{
    [editableText insertText:kLeftParenthesis];
}

- (IBAction) doRightParenthesis:(id)sender
{
    [editableText insertText:kRightParenthesis];
}

- (IBAction) doCoupleParenthesis:(id)sender
{
    [editableText insertText:kCoupleParenthesis];
    [self moveInsertionPointBy:7];
}

- (IBAction) doLeftBracket:(id)sender
{
    [editableText insertText:kLeftBracket];
}

- (IBAction) doRightBracket:(id)sender
{
    [editableText insertText:kRightBracket];
}

- (IBAction) doCoupleBracket:(id)sender
{
    [editableText insertText:kCoupleBracket];
    [self moveInsertionPointBy:7];
}

- (IBAction) doLeftBrace:(id)sender
{
    [editableText insertText:kLeftBrace];
}

- (IBAction) doRightBrace:(id)sender
{
    [editableText insertText:kRightBrace];
}

- (IBAction) doCoupleBrace:(id)sender
{
    [editableText insertText:kCoupleBrace];
    [self moveInsertionPointBy:8];
}

- (IBAction) doLeftAngle:(id)sender
{
    [editableText insertText:kLeftAngle];
}

- (IBAction) doRightAngle:(id)sender
{
    [editableText insertText:kRightAngle];
}

- (IBAction) doCoupleAngle:(id)sender
{
    [editableText insertText:kCoupleAngle];
    [self moveInsertionPointBy:7];
}

- (IBAction) dolfloor:(id)sender
{
    [editableText insertText:klfloor];
}

- (IBAction) dolceil:(id)sender
{
    [editableText insertText:klceil];
}

- (IBAction) dorfloor:(id)sender
{
    [editableText insertText:krfloor];
}

- (IBAction) dorceil:(id)sender
{
    [editableText insertText:krceil];
}

- (IBAction) doleftvbar:(id)sender
{
    [editableText insertText:kleftvbar];
}

- (IBAction) dorightvbar:(id)sender
{
    [editableText insertText:krightvbar];
}

- (IBAction) docouplevbar:(id)sender
{
    [editableText insertText:kcouplevbar];
    [self moveInsertionPointBy:7];
}

- (IBAction) doleq:(id)sender
{
    [editableText insertText:kleq];
}

- (IBAction) doprec:(id)sender
{
    [editableText insertText:kprec];
}

- (IBAction) dopreceq:(id)sender
{
    [editableText insertText:kpreceq];
}

- (IBAction) doll:(id)sender
{
    [editableText insertText:kll];
}

- (IBAction) dosubset:(id)sender
{
    [editableText insertText:ksubset];
}

- (IBAction) dosubseteq:(id)sender
{
    [editableText insertText:ksubseteq];
}

- (IBAction) dosqsubset:(id)sender
{
    [editableText insertText:ksqsubset];
}

- (IBAction) dosqsubseteq:(id)sender
{
    [editableText insertText:ksqsubseteq];
}

- (IBAction) doin:(id)sender
{
    [editableText insertText:kin];
}

- (IBAction) dovdash:(id)sender
{
    [editableText insertText:kvdash];
}

- (IBAction) dogeq:(id)sender
{
    [editableText insertText:kgeq];
}

- (IBAction) dosucc:(id)sender
{
    [editableText insertText:ksucc];
}

- (IBAction) dosucceq:(id)sender
{
    [editableText insertText:ksucceq];
}

- (IBAction) dogg:(id)sender
{
    [editableText insertText:kgg];
}

- (IBAction) dosupset:(id)sender
{
    [editableText insertText:ksupset];
}

- (IBAction) dosupseteq:(id)sender
{
    [editableText insertText:ksupseteq];
}

- (IBAction) dosqsupset:(id)sender
{
    [editableText insertText:ksqsupset];
}

- (IBAction) dosqsupseteq:(id)sender
{
    [editableText insertText:ksqsupseteq];
}

- (IBAction) doni:(id)sender
{
    [editableText insertText:kni];
}

- (IBAction) dodashv:(id)sender
{
    [editableText insertText:kdashv];
}

- (IBAction) doequiv:(id)sender
{
    [editableText insertText:kequiv];
}

- (IBAction) dosim:(id)sender
{
    [editableText insertText:ksim];
}

- (IBAction) dosimeq:(id)sender
{
    [editableText insertText:ksimeq];
}

- (IBAction) doasymp:(id)sender
{
    [editableText insertText:kasymp];
}

- (IBAction) doapprox:(id)sender
{
    [editableText insertText:kapprox];
}

- (IBAction) docong:(id)sender
{
    [editableText insertText:kcong];
}

- (IBAction) doneq:(id)sender
{
    [editableText insertText:kneq];
}

- (IBAction) dodoteq:(id)sender
{
    [editableText insertText:kdoteq];
}

- (IBAction) dopropto:(id)sender
{
    [editableText insertText:kpropto];
}

- (IBAction) domodels:(id)sender
{
    [editableText insertText:kmodels];
}

- (IBAction) doperp:(id)sender
{
    [editableText insertText:kperp];
}

- (IBAction) domid:(id)sender
{
    [editableText insertText:kmid];
}

- (IBAction) doparallel:(id)sender
{
    [editableText insertText:kparallel];
}

- (IBAction) dobowtie:(id)sender
{
    [editableText insertText:kbowtie];
}

- (IBAction) doJoin:(id)sender
{
    [editableText insertText:kJoin];
}

- (IBAction) dosmile:(id)sender
{
    [editableText insertText:ksmile];
}

- (IBAction) dofrown:(id)sender
{
    [editableText insertText:kfrown];
}

- (IBAction) dosum:(id)sender
{
    [editableText insertText:ksum];
}

- (IBAction) doprod:(id)sender
{
    [editableText insertText:kprod];
}

- (IBAction) docoprod:(id)sender
{
    [editableText insertText:kcoprod];
}

- (IBAction) doint:(id)sender
{
    [editableText insertText:kint];
}

- (IBAction) dooint:(id)sender
{
    [editableText insertText:koint];
}

- (IBAction) dobigcap:(id)sender
{
    [editableText insertText:kbigcap];
}

- (IBAction) dobigcup:(id)sender
{
    [editableText insertText:kbigcup];
}

- (IBAction) dobigsqcup:(id)sender
{
    [editableText insertText:kbigsqcup];
}

- (IBAction) dobigvee:(id)sender
{
    [editableText insertText:kbigvee];
}

- (IBAction) dobigwedge:(id)sender
{
    [editableText insertText:kbigwedge];
}

- (IBAction) dobigodot:(id)sender
{
    [editableText insertText:kbigodot];
}

- (IBAction) dobigotimes:(id)sender
{
    [editableText insertText:kbigotimes];
}

- (IBAction) dobigoplus:(id)sender
{
    [editableText insertText:kbigoplus];
}

- (IBAction) dobiguplus:(id)sender
{
    [editableText insertText:kbiguplus];
}

- (IBAction) doleftarrow:(id)sender
{
    [editableText insertText:kleftarrow];
}

- (IBAction) doLeftarrow:(id)sender
{
    [editableText insertText:kLeftarrow];
}

- (IBAction) dorightarrow:(id)sender
{
    [editableText insertText:krightarrow];
}

- (IBAction) doRightarrow:(id)sender
{
    [editableText insertText:kRightarrow];
}

- (IBAction) doleftrightarrow:(id)sender
{
    [editableText insertText:kleftrightarrow];
}

- (IBAction) doLeftrightarrow:(id)sender
{
    [editableText insertText:kLeftrightarrow];
}

- (IBAction) domapsto:(id)sender
{
    [editableText insertText:kmapsto];
}

- (IBAction) dohookleftarrow:(id)sender
{
    [editableText insertText:khookleftarrow];
}

- (IBAction) doleftharpoonup:(id)sender
{
    [editableText insertText:kleftharpoonup];
}

- (IBAction) doleftharpoondown:(id)sender
{
    [editableText insertText:kleftharpoondown];
}

- (IBAction) dorightleftharpoons:(id)sender
{
    [editableText insertText:krightleftharpoons];
}

- (IBAction) dolongleftarrow:(id)sender
{
    [editableText insertText:klongleftarrow];
}

- (IBAction) doLongleftarrow:(id)sender
{
    [editableText insertText:kLongleftarrow];
}

- (IBAction) dolongrightarrow:(id)sender
{
    [editableText insertText:klongrightarrow];
}

- (IBAction) doLongrightarrow:(id)sender
{
    [editableText insertText:kLongrightarrow];
}

- (IBAction) dolongleftrightarrow:(id)sender
{
    [editableText insertText:klongleftrightarrow];
}

- (IBAction) doLongleftrightarrow:(id)sender
{
    [editableText insertText:kLongleftrightarrow];
}

- (IBAction) dolongmapsto:(id)sender
{
    [editableText insertText:klongmapsto];
}

- (IBAction) dohookrightarrow:(id)sender
{
    [editableText insertText:khookrightarrow];
}

- (IBAction) dorightharpoonup:(id)sender
{
    [editableText insertText:krightharpoonup];
}

- (IBAction) dorightharpoondown:(id)sender
{
    [editableText insertText:krightharpoondown];
}

- (IBAction) doleadsto:(id)sender
{
    [editableText insertText:kleadsto];
}

- (IBAction) douparrow:(id)sender
{
    [editableText insertText:kuparrow];
}

- (IBAction) doUparrow:(id)sender
{
    [editableText insertText:kUparrow];
}

- (IBAction) dodownarrow:(id)sender
{
    [editableText insertText:kdownarrow];
}

- (IBAction) doDownarrow:(id)sender
{
    [editableText insertText:kDownarrow];
}

- (IBAction) doupdownarrow:(id)sender
{
    [editableText insertText:kupdownarrow];
}

- (IBAction) doUpdownarrow:(id)sender
{
    [editableText insertText:kUpdownarrow];
}

- (IBAction) donearrow:(id)sender
{
    [editableText insertText:knearrow];
}

- (IBAction) dosearrow:(id)sender
{
    [editableText insertText:ksearrow];
}

- (IBAction) doswarrow:(id)sender
{
    [editableText insertText:kswarrow];
}

- (IBAction) donwarrow:(id)sender
{
    [editableText insertText:knwarrow];
}

- (IBAction) doaleph:(id)sender
{
    [editableText insertText:kaleph];
}

- (IBAction) dohbar:(id)sender
{
    [editableText insertText:khbar];
}

- (IBAction) doimath:(id)sender
{
    [editableText insertText:kimath];
}

- (IBAction) dojmath:(id)sender
{
    [editableText insertText:kjmath];
}

- (IBAction) doell:(id)sender
{
    [editableText insertText:kell];
}

- (IBAction) dowp:(id)sender
{
    [editableText insertText:kwp];
}

- (IBAction) doRe:(id)sender
{
    [editableText insertText:kRe];
}

- (IBAction) doIm:(id)sender
{
    [editableText insertText:kIm];
}

- (IBAction) domho:(id)sender
{
    [editableText insertText:kmho];
}

- (IBAction) doprime:(id)sender
{
    [editableText insertText:kprime];
}

- (IBAction) doemptyset:(id)sender
{
    [editableText insertText:kemptyset];
}

- (IBAction) donabla:(id)sender
{
    [editableText insertText:knabla];
}

- (IBAction) dosurd:(id)sender
{
    [editableText insertText:ksurd];
}

- (IBAction) dotop:(id)sender
{
    [editableText insertText:ktop];
}

- (IBAction) dobot:(id)sender
{
    [editableText insertText:kbot];
}

- (IBAction) dodoubleVertBar:(id)sender
{
    [editableText insertText:kdoubleVertBar];
}

- (IBAction) doangle:(id)sender
{
    [editableText insertText:kangle];
}

- (IBAction) doforall:(id)sender
{
    [editableText insertText:kforall];
}

- (IBAction) doexists:(id)sender
{
    [editableText insertText:kexists];
}

- (IBAction) doneg:(id)sender
{
    [editableText insertText:kneg];
}

- (IBAction) doflat:(id)sender
{
    [editableText insertText:kflat];
}

- (IBAction) donatural:(id)sender
{
    [editableText insertText:knatural];
}

- (IBAction) dosharp:(id)sender
{
    [editableText insertText:ksharp];
}

- (IBAction) dobackslash:(id)sender
{
    [editableText insertText:kbackslash];
}

- (IBAction) dopartial:(id)sender
{
    [editableText insertText:kpartial];
}

- (IBAction) doinfty:(id)sender
{
    [editableText insertText:kinfty];
}

- (IBAction) doBox:(id)sender
{
    [editableText insertText:kBox];
}

- (IBAction) doDiamond:(id)sender
{
    [editableText insertText:kDiamond];
}

- (IBAction) dotriangle:(id)sender
{
    [editableText insertText:ktriangle];
}

- (IBAction) doclubsuit:(id)sender
{
    [editableText insertText:kclubsuit];
}

- (IBAction) dodiamondsuit:(id)sender
{
    [editableText insertText:kdiamondsuit];
}

- (IBAction) doheartsuit:(id)sender
{
    [editableText insertText:kheartsuit];
}

- (IBAction) dospadesuit:(id)sender
{
    [editableText insertText:kspadesuit];
}

- (IBAction) doarccos:(id)sender
{
    [editableText insertText:karccos];
}

- (IBAction) doarcsin:(id)sender
{
    [editableText insertText:karcsin];
}

- (IBAction) doarctan:(id)sender
{
    [editableText insertText:karctan];
}

- (IBAction) doarg:(id)sender
{
    [editableText insertText:karg];
}

- (IBAction) docos:(id)sender
{
    [editableText insertText:kcos];
}

- (IBAction) docosh:(id)sender
{
    [editableText insertText:kcosh];
}

- (IBAction) docot:(id)sender
{
    [editableText insertText:kcot];
}

- (IBAction) docoth:(id)sender
{
    [editableText insertText:kcoth];
}

- (IBAction) docsc:(id)sender
{
    [editableText insertText:kcsc];
}

- (IBAction) dodeg:(id)sender
{
    [editableText insertText:kdeg];
}

- (IBAction) dodet:(id)sender
{
    [editableText insertText:kdet];
}

- (IBAction) dodim:(id)sender
{
    [editableText insertText:kdim];
}

- (IBAction) doexp:(id)sender
{
    [editableText insertText:kexp];
}

- (IBAction) dogcd:(id)sender
{
    [editableText insertText:kgcd];
}

- (IBAction) dohom:(id)sender
{
    [editableText insertText:khom];
}

- (IBAction) doinf:(id)sender
{
    [editableText insertText:kinf];
}

- (IBAction) doker:(id)sender
{
    [editableText insertText:kker];
}

- (IBAction) dolg:(id)sender
{
    [editableText insertText:klg];
}

- (IBAction) dolim:(id)sender
{
    [editableText insertText:klim];
}

- (IBAction) doliminf:(id)sender
{
    [editableText insertText:kliminf];
}

- (IBAction) dolimsup:(id)sender
{
    [editableText insertText:klimsup];
}

- (IBAction) doln:(id)sender
{
    [editableText insertText:kln];
}

- (IBAction) dolog:(id)sender
{
    [editableText insertText:klog];
}

- (IBAction) domax:(id)sender
{
    [editableText insertText:kmax];
}

- (IBAction) domin:(id)sender
{
    [editableText insertText:kmin];
}

- (IBAction) doPr:(id)sender
{
    [editableText insertText:kPr];
}

- (IBAction) dosec:(id)sender
{
    [editableText insertText:ksec];
}

- (IBAction) dosin:(id)sender
{
    [editableText insertText:ksin];
}

- (IBAction) dosinh:(id)sender
{
    [editableText insertText:ksinh];
}

- (IBAction) dosup:(id)sender
{
    [editableText insertText:ksup];
}

- (IBAction) dotan:(id)sender
{
    [editableText insertText:ktan];
}

- (IBAction) dotanh:(id)sender
{
    [editableText insertText:ktanh];
}

- (IBAction) dobmod:(id)sender
{
    [editableText insertText:kbmod];
}

- (IBAction) dopmod:(id)sender
{
    [editableText insertText:kpmod];
    [self moveInsertionPointBy:1];
}

- (IBAction) dooe:(id)sender
{
    [editableText insertText:koe];
}

- (IBAction) doOE:(id)sender
{
    [editableText insertText:kOE];
}

- (IBAction) doae:(id)sender
{
    [editableText insertText:kae];
}

- (IBAction) doAE:(id)sender
{
    [editableText insertText:kAE];
}

- (IBAction) doaa:(id)sender
{
    [editableText insertText:kaa];
}

- (IBAction) doAA:(id)sender
{
    [editableText insertText:kAA];
}

- (IBAction) doobar:(id)sender
{
    [editableText insertText:kobar];
}

- (IBAction) doO:(id)sender
{
    [editableText insertText:kO];
}

- (IBAction) dol:(id)sender
{
    [editableText insertText:kl];
}

- (IBAction) doL:(id)sender
{
    [editableText insertText:kL];
}

- (IBAction) doss:(id)sender
{
    [editableText insertText:kss];
}

- (IBAction) doQuestionMark:(id)sender
{
    [editableText insertText:kQuestionMark];
}

- (IBAction) doExclamationMark:(id)sender
{
    [editableText insertText:kExclamationMark];
}

- (IBAction) dohat:(id)sender
{
    [editableText insertText:khat];
    [self moveInsertionPointBy:1];
}

- (IBAction) docheck:(id)sender
{
    [editableText insertText:kcheck];
    [self moveInsertionPointBy:1];
}

- (IBAction) dobreve:(id)sender
{
    [editableText insertText:kbreve];
    [self moveInsertionPointBy:1];
}

- (IBAction) doacute:(id)sender
{
    [editableText insertText:kacute];
    [self moveInsertionPointBy:1];
}

- (IBAction) dograve:(id)sender
{
    [editableText insertText:kgrave];
    [self moveInsertionPointBy:1];
}

- (IBAction) dotilde:(id)sender
{
    [editableText insertText:ktilde];
    [self moveInsertionPointBy:1];
}

- (IBAction) dobar:(id)sender
{
    [editableText insertText:kbar];
    [self moveInsertionPointBy:1];
}

- (IBAction) dovec:(id)sender
{
    [editableText insertText:kvec];
    [self moveInsertionPointBy:1];
}

- (IBAction) dodot:(id)sender
{
    [editableText insertText:kdot];
    [self moveInsertionPointBy:1];
}

- (IBAction) doddot:(id)sender
{
    [editableText insertText:kddot];
    [self moveInsertionPointBy:1];
}

- (IBAction) dooverline:(id)sender
{
    [editableText insertText:koverline];
    [self moveInsertionPointBy:1];
}

- (IBAction) dounderline:(id)sender
{
    [editableText insertText:kunderline];
    [self moveInsertionPointBy:1];
}

- (IBAction) dooverbrace:(id)sender
{
    [editableText insertText:koverbrace];
    [self moveInsertionPointBy:1];
}

- (IBAction) dounderbrace:(id)sender
{
    [editableText insertText:kunderbrace];
    [self moveInsertionPointBy:1];
}

- (IBAction) dothinspace:(id)sender;
{
    [editableText insertText:kthinspace];
}

- (IBAction) donegthinspace:(id)sender
{
    [editableText insertText:knegthinspace];
}

- (IBAction) domediumspace:(id)sender
{
    [editableText insertText:kmediumspace];
}

- (IBAction) dothickspace:(id)sender
{
    [editableText insertText:kthickspace];
}

- (IBAction) dowordspace:(id)sender
{
    [editableText insertText:kwordspace];
}

- (IBAction) dostacking:(id)sender
{
    [editableText insertText:kstacking];
    [self moveInsertionPointBy:3];
}

- (void)readDefaults
{
    NSUserDefaults	*defs=[NSUserDefaults standardUserDefaults];
    
    if([defs objectForKey:kTeXFoG_Version_pref]!=nil)
    {
        [version setString:[defs objectForKey:kTeXFoG_Version_pref]];
        moveInsertionPoint=[defs boolForKey:kTeXFoG_MoveInsertionPoint_pref];
        useModifierKey=[defs boolForKey:kTeXFoG_UseModifierKey_pref];
        whatModifierKey=[defs integerForKey:kTeXFoG_WhatModifierKey_pref];
		if(editor)
			[editor release];
		if([defs objectForKey:kTeXFoG_Editor_pref])
			editor=[[NSString alloc] initWithString:[defs objectForKey:kTeXFoG_Editor_pref]];
		else
			editor=[[NSString alloc] initWithString:kDefaultEditor];
		
		{
			NSMutableString		*tmp;
			
			if([defs objectForKey:kTeXFoG_latex_pref])
				tmp=[NSMutableString stringWithString:[defs objectForKey:kTeXFoG_latex_pref]];
			else
				tmp=[NSMutableString stringWithString:kDefaultLaTeX];
			if([[tmp substringWithRange:NSMakeRange([tmp length]-1,1)] caseInsensitiveCompare:@"/"]!=NSOrderedSame)
				[tmp appendString:@"/"];
			latexEnginePath=[[NSString alloc] initWithString:tmp];
		}
		{
			NSMutableString		*tmp;
			
			if([defs objectForKey:kTeXFoG_ghostscript_pref])
				tmp=[[NSMutableString alloc] initWithString:[defs objectForKey:kTeXFoG_ghostscript_pref]];
			else
				tmp=[[NSMutableString alloc] initWithString:kDefaultGhostscript];
			if([[tmp substringWithRange:NSMakeRange([tmp length]-1,1)] caseInsensitiveCompare:@"/"]!=NSOrderedSame)
				[tmp appendString:@"/"];
			ghostscriptEnginePath=[[NSString alloc] initWithString:tmp];
		}
    }
}

- (void)setFirstTimeDefaults
{
    NSUserDefaults	*defs=[NSUserDefaults standardUserDefaults];
    
    [defs setObject:kDefaultVersionString forKey:kTeXFoG_Version_pref];
    [defs setBool:kDefaultMoveInsertionPoint forKey:kTeXFoG_MoveInsertionPoint_pref];
    [defs setBool:kDefaultUseModifierKey forKey:kTeXFoG_UseModifierKey_pref];
    [defs setInteger:kDefaultWhatModifierKey forKey:kTeXFoG_WhatModifierKey_pref];
	[defs setObject:kDefaultEditor forKey:kTeXFoG_Editor_pref];
	[defs setObject:kDefaultLaTeX forKey:kTeXFoG_latex_pref];
	[defs setObject:kDefaultGhostscript forKey:kTeXFoG_ghostscript_pref];
    [defs synchronize];
}

- (void)moveInsertionPointBy:(int)places
{
    NSRange		range;
    BOOL		move;
    
    if(moveInsertionPoint)
    {
        if(useModifierKey)
        {
            switch(whatModifierKey)
            {
                case kShiftKey:
                    if([[[NSApplication sharedApplication] currentEvent] modifierFlags]&NSShiftKeyMask)
                        move=NO;
                    else
                        move=YES;
                    break;
                case kOptionKey:
                    if([[[NSApplication sharedApplication] currentEvent] modifierFlags]&NSAlternateKeyMask)
                        move=NO;
                    else
                        move=YES;
                    break;
                case kCommandKey:
                    if([[[NSApplication sharedApplication] currentEvent] modifierFlags]&NSCommandKeyMask)
                        move=NO;
                    else
                        move=YES;
                    break;
                case kControlKey:
                    if([[[NSApplication sharedApplication] currentEvent] modifierFlags]&NSControlKeyMask)
                        move=NO;
                    else
                        move=YES;
                    break;
            }
        }
        else
            move=YES;
    }
    else
        move=NO;
    
    if(move)
    {
        range=[editableText selectedRange];
        //NSLog(@"%d %d",range.location,range.length);
        [editableText setSelectedRange:NSMakeRange(range.location-places,range.length)];
    }
}

- (IBAction) pasteIntoEditor:(id)sender
{
	NSAppleScript		*as;
	NSMutableString		*comando;
	NSDictionary		*errore;
	NSRange selezione=[editableText selectedRange];
	if(selezione.length==0)
		selezione=NSMakeRange(0,[[editableText string] length]);
	NSMutableString *testo=[NSMutableString stringWithString:[[editableText string] substringWithRange:selezione]];
	// escaping backslashes
	[testo replaceOccurrencesOfString:@"\\" withString:@"\\\\" options:NSLiteralSearch range:NSMakeRange(0,[testo length])];
	//NSLog(testo);
	comando=[[NSMutableString alloc] initWithString:@"set the clipboard to \""];
	[comando appendString:testo];
	[comando appendString:@"\"\n"];
	[comando appendString:@"tell application \""];
	[comando appendString:editor];
	[comando appendString:@"\" to activate\n"];
	[comando appendString:@"tell application \"System Events\" to keystroke \"v\" using command down"];
	as=[[NSAppleScript alloc] initWithSource:comando];
	if([as executeAndReturnError:&errore]==nil)
		NSLog([errore description]);
	[comando release];
	[as release];
}

- (IBAction) typeset:(id)sender
{
	NSMutableString		*latex;
	NSMutableString		*testo;
	NSMutableString		*comando;
	NSTask				*task;
	NSWorkspace			*ws=[NSWorkspace sharedWorkspace];
	NSString			*cmd;
	
	NSRange	selezione=[editableText selectedRange];
	if(selezione.length==0)
		selezione=NSMakeRange(0,[[editableText string] length]);
	latex=[NSMutableString stringWithString:kPreamble];
	testo=[NSMutableString stringWithString:[[editableText string] substringWithRange:selezione]];
	//[testo replaceOccurrencesOfString:@"\\" withString:@"\\\\" options:NSLiteralSearch range:NSMakeRange(0,[testo length])];
	[latex appendString:testo];
	[latex appendString:kPostamble];
	[latex writeToFile:kTempLaTeXFile atomically:YES encoding:NSASCIIStringEncoding error:nil];
	
	cmd=[NSString stringWithString:latexEnginePath];
	//comando=[NSMutableString stringWithString:latexEnginePath];
	//[comando appendString:kpdflatexCommand];
	comando=[NSMutableString stringWithString:[cmd stringByAppendingPathComponent:kpdflatexCommand]];
	task=[[NSTask alloc] init];
	[task setLaunchPath:comando];
	[task setArguments:[NSArray arrayWithObject:kTempLaTeXFile]];
	[task setCurrentDirectoryPath:kTempFolder];
	[task launch];
	[task waitUntilExit];
	[task release];
	
	{
		//NSMutableString		*envPath;
		
		//task=[[NSTask alloc] init];
		cmd=[NSString stringWithString:latexEnginePath];
		//comando=[NSMutableString stringWithString:latexEnginePath];
		comando=[NSMutableString stringWithString:[cmd stringByAppendingPathComponent:kpdfcropCommand]];
		//[comando appendString:kpdfcropCommand];
		[comando appendString:@" -pdftexcmd "];
		[comando appendString:latexEnginePath];
		[comando appendString:kpdftexCommand];
		[comando appendString:@" --gscmd "];
		[comando appendString:ghostscriptEnginePath];
		[comando appendString:kgsCommand];
		//[task setLaunchPath:comando];
		//[task setArguments:[NSArray arrayWithObjects:kTemppdfFile,nil]];
		//[task setCurrentDirectoryPath:kTempFolder];
		//envPath=[NSMutableString stringWithString:@"/usr/bin/:"];
		//[envPath appendString:latexEnginePath];
		//[envPath appendString:@":"];
		//[envPath appendString:ghostscriptEnginePath];
		//[task setEnvironment:[NSDictionary dictionaryWithObject:envPath forKey:kEnvironmentPathKey]];
		//[task launch];
		//NSLog([[task environment] description]);
		//[task waitUntilExit];
		//[task release];
		[comando appendString:@" "];
		[comando appendString:kTemppdfFile];
		system([comando cString]);
		[ws openFile:kTempCroppedFile];
	}
}

@end
